﻿using System;
using System.Collections.Generic;
using System.Windows.Media;

namespace HighlightsUILayerDemo
{
    public class HighlightsManager
    {
        private readonly Dictionary<int, PathGeometry> pageIndexToGeometry;

        public HighlightsManager()
        {
            this.pageIndexToGeometry = new Dictionary<int, PathGeometry>();
        }

        public void AddHighlight(int pageIndex, PathFigure figure)
        {
            PathGeometry geometry = GetHighlights(pageIndex);
            geometry.Figures.Add(figure);
        }

        public PathGeometry GetHighlights(int pageIndex)
        {
            PathGeometry geometry;

            if (!this.pageIndexToGeometry.TryGetValue(pageIndex, out geometry))
            {
                geometry = new PathGeometry();
                geometry.FillRule = FillRule.Nonzero;
                this.pageIndexToGeometry[pageIndex] = geometry;
            }

            return geometry;
        }

        public void Clear()
        {
            this.pageIndexToGeometry.Clear();
        }
    }
}
