﻿using System;
using System.Windows.Controls;
using System.Windows.Media;
using System.Windows.Shapes;
using Telerik.Windows.Documents.Fixed.UI.Layers;

namespace HighlightsUILayerDemo
{
    public class HighlightsUILayer : IUILayer
    {
        private readonly HighlightsManager highlightsManager;
        private readonly Canvas container;
        private Path path = null;
        private int pageIndex = -1;

        public HighlightsUILayer(HighlightsManager highlightsManager)
        {
            this.highlightsManager = highlightsManager;
            this.container = new Canvas();
        }
 
        public string Name
        {
            get
            {
                return "HighlightsUILayer";
            }
        }
 
        public void Initialize(UILayerInitializeContext context)
        {
            this.path = new Path()
            {
                Fill = new SolidColorBrush(Colors.Yellow)                
            };

            this.pageIndex = context.Page.PageNo - 1; 
            this.container.Children.Add(this.path);
        }
 
        public void Update(UILayerUpdateContext context)
        {
            if (this.path != null)
            {
                this.path.Data = this.highlightsManager.GetHighlights(this.pageIndex);
            }
        }
 
        public void Clear()
        {
            this.container.Children.Clear();
        }
 
        public Canvas UIElement
        {
            get
            {
                return this.container;
            }
        }
    }
}
